/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */
#include <device/conf.h>


extern int block_io_mmap();


/* Built-in keyboard */
extern int	kdopen(), kdclose(), kdread(), kdwrite();
extern int	kdgetstat(), kdsetstat(), kdportdeath(), kdmmap();
#define	kdname			"kd"

/* Timer */
extern int timeopen(),timeclose(),timemmap();
#define timename	"time"

/* Built-in serial port */
extern int utopen(), utclose(), utread(), utwrite();
extern int utgetstat(), utsetstat(), utportdeath();
#define utname "ut"

/* SCSI driver */
#if defined (A3000) || defined (A2091) || defined (GVP11)
#define rz_name "sd"
extern int rz_get_status(), rz_set_status(), rz_devinfo();
extern int rz_open(), rz_close(), rz_read(), rz_write();
#endif



/*
 * List of devices - console must be at slot 0 and null at 1
 */
struct dev_ops	dev_name_list[] =
{
	/*name,		open,		close,		read,
	  write,	getstat,	setstat,	mmap,
	  async_in,	reset,		port_death,	subdev,
	  dev_info */

	{ kdname,	kdopen,		kdclose,	kdread,
	  kdwrite,	kdgetstat,	kdsetstat,	kdmmap,
	  nodev,	nulldev,	kdportdeath },

	{ "null",	nulldev,	nulldev,	nulldev,
	  nulldev,	nulldev,	nulldev,	nodev,
	  nodev,	nulldev,	nulldev,	0,
	  nodev },

	{ timename,	timeopen,	timeclose,	nulldev,
	  nulldev,	nulldev,	nulldev,	timemmap,
	  nodev,	nulldev,	nulldev,	0,
	  nodev },

	{ utname,	utopen, 	utclose,	utread,
	  utwrite,	utgetstat,	utsetstat,	nodev,
	  nodev,	nulldev,	utportdeath,	0,
	  nodev },

#if defined (A3000) || defined (A2091) || defined (GVP11)
	{ rz_name,	rz_open,	rz_close,	rz_read,
	  rz_write,	rz_get_status,	rz_set_status,	nodev,
	  nodev,	nulldev,	nulldev,	8,
	  rz_devinfo },
#endif

};
int	dev_name_count = sizeof(dev_name_list)/sizeof(dev_name_list[0]);

/*
 * Indirect list.
 */
struct dev_indirect dev_indirect_list[] = {

	{ "console",	&dev_name_list[0],	0 },
	{ "kbd",	&dev_name_list[1],	0 },
	{ "mouse",	&dev_name_list[1],	0 },
	{ "fb",		&dev_name_list[1],	0 },
};
int dev_indirect_count = sizeof(dev_indirect_list)/sizeof(dev_indirect_list[0]);
